require 'paytrail'

class Paytrail::MerchantApi
    # Example usage
    #
    # require 'paytrail/merchantapi'
    #
    # merchantApi = Paytrail::MerchantApi.new(13466, '6pKF4jkv97zmqBJ3ZL8gUw5DfT2NMQ', 'https://api.paytrail.com')
    # response = merchantApi.createRefund(
    #     'ORD-59867',
    #     'test@paytrail.com',
    #     [{
    #         :amount => 100,
    #         :vatPercent => 1000,
    #         :description => 'Refund for item 123'
    #     }],
    #     'http://paytrail.com'
    # )
    #
    # refundToken = nil
    #
    # if response.code == '202'
    #     puts 'Refund created!'
    #     location = response.get_fields('location')
    #     refundToken = location[0].split('/')[-1]
    # else
    #     puts 'ERROR'
    #     print 'HTTP code: '
    #     puts response.code
    #     puts response.body
    # end
    #
    # if refundToken
    #     response = merchantApi.deleteRefund(refundToken)
    #
    #     if response.code == '204'
    #         puts 'Refund deleted!'
    #     else
    #         puts 'ERROR'
    #         print 'HTTP code: '
    #         puts response.code
    #         puts response.body
    #     end
    # end

    @@apiName = 'PaytrailMerchantAPI'

    def initialize(apiKey, secret, uri)
        @paytrail = Paytrail.new(@@apiName, apiKey, secret)
        @uri = uri
    end

    def createRefund(orderNumber, email, refundRows, notifyUrl)
        data = {
            :email => email,
            :rows => refundRows
        }

        if notifyUrl
            data[:notifyUrl] = notifyUrl
        end

        data = data.to_json
        location = '/merchant/v1/payments/%s/refunds' % [orderNumber]
        headers = @paytrail.makeHeaders('POST', location, @paytrail.makeTimestamp, data)

        @paytrail.post(@uri + location, headers, data)
    end

    def deleteRefund(refundToken)
        location = '/merchant/v1/refunds/%s' % [refundToken]
        headers = @paytrail.makeHeaders('DELETE', location, @paytrail.makeTimestamp, '')

        @paytrail.delete(@uri + location, headers)
    end
end